# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .app_shared_v_0_schema_audio_segment import AppSharedV0SchemaAudioSegment
from .app_shared_v_0_schema_shot import AppSharedV0SchemaShot
from .asset_type import AssetType
from .preview_images import PreviewImages
from .video_asset import VideoAsset

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class AssetResponse(pydantic.BaseModel):
    """
    An image, video keyframe, or video
    """

    asset_type: AssetType = pydantic.Field(alias="assetType", description="The type of asset")
    coactive_image_id: str = pydantic.Field(
        alias="coactiveImageId", description="The coactive image id (if the asset_type is 'image' or 'keyframe')"
    )
    preview_images: PreviewImages = pydantic.Field(alias="previewImages", description="Preview images in various sizes")
    path: typing.Optional[str] = pydantic.Field(
        description="The original path of the asset. This is the video path if the asset_type is 'keyframe'."
    )
    video: typing.Optional[VideoAsset] = pydantic.Field(description="Video metadata (if the asset_type is 'keyframe').")
    shot: typing.Optional[AppSharedV0SchemaShot] = pydantic.Field(
        description="Video shot metadata (if the asset_type is 'keyframe')"
    )
    sensitive: typing.Optional[bool] = pydantic.Field(description="Flag for a sensitive content warning")
    audio_segment: typing.Optional[AppSharedV0SchemaAudioSegment] = pydantic.Field(
        alias="audioSegment", description="Audio segment associated with the keyframe (if the asset_type is 'keyframe')"
    )
    image_id: typing.Optional[str] = pydantic.Field(
        alias="imageId", description="The user provided image id (if the asset_type is 'image')"
    )
    format: typing.Optional[str] = pydantic.Field(description="The file extension of the asset")
    metadata: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="User provided metadata for the asset"
    )
    created_dt: dt.datetime = pydantic.Field(alias="createdDt", description="The created timestamp of the asset")
    updated_dt: dt.datetime = pydantic.Field(alias="updatedDt", description="The updated timestamp of the asset")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
