# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .column_data_type import ColumnDataType
from .column_display_type import ColumnDisplayType
from .column_style import ColumnStyle

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Column(pydantic.BaseModel):
    """
    A representation of a table column
    """

    key: str = pydantic.Field(description="The for the row value in the row data list object")
    label: typing.Optional[str] = pydantic.Field(description="The display value for the column name")
    display_type: typing.Optional[ColumnDisplayType] = pydantic.Field(
        alias="displayType", description="The display type of the row values"
    )
    style: typing.Optional[ColumnStyle] = pydantic.Field(description="The style of the row values")
    to: typing.Optional[str] = pydantic.Field(description="Link template, ex. /path/to/{some_var}")
    hide_label: typing.Optional[bool] = pydantic.Field(
        alias="hideLabel", description="Optionally hide the column label in the table header"
    )
    data_type: typing.Optional[ColumnDataType] = pydantic.Field(
        alias="dataType", description="The format to display the row value in the UI"
    )
    empty_text: typing.Optional[str] = pydantic.Field(
        alias="emptyText", description="The default string to display when value is None"
    )
    unit: typing.Optional[str] = pydantic.Field(description="The unit to display in a chart")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
