# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .asset_type import AssetType
from .concept_label_enum import ConceptLabelEnum

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ConceptLabel(pydantic.BaseModel):
    """
    An association of an image or video keyframe to a concept
    """

    label_id: str = pydantic.Field(alias="labelId", description="The label id")
    label: ConceptLabelEnum = pydantic.Field(description="The label for the image or video keyframe")
    coactive_image_id: str = pydantic.Field(
        alias="coactiveImageId", description="The id of the labelled image or video keyframe"
    )
    asset_type: AssetType = pydantic.Field(alias="assetType", description="The asset type of the label")
    image_path: typing.Optional[str] = pydantic.Field(alias="imagePath", description="The original path of the image")
    video_path: typing.Optional[str] = pydantic.Field(alias="videoPath", description="The original path of the video")
    video_id: typing.Optional[str] = pydantic.Field(
        alias="videoId", description="The timestamp of this keyframe in its original video"
    )
    shot_id: typing.Optional[str] = pydantic.Field(
        alias="shotId", description="The timestamp of this keyframe in its original video"
    )
    video_timestamp: typing.Optional[int] = pydantic.Field(
        alias="videoTimestamp", description="The timestamp of this keyframe in its original video"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
