# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Image(pydantic.BaseModel):
    """
    An image asset response
    """

    coactive_image_id: str = pydantic.Field(alias="coactiveImageId", description="The coactive image id")
    path: str = pydantic.Field(description="The original path of the asset.")
    image_id: typing.Optional[str] = pydantic.Field(alias="imageId", description="The customer provided image id.")
    format: str = pydantic.Field(description="The extension type of the image.")
    metadata: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="The user provided metadata for the image."
    )
    created_dt: dt.datetime = pydantic.Field(alias="createdDt", description="The created timestamp of the image")
    created_user_id: str = pydantic.Field(alias="createdUserId", description="The user that created the image")
    updated_dt: dt.datetime = pydantic.Field(alias="updatedDt", description="The updated timestamp of the image")
    updated_user_id: str = pydantic.Field(alias="updatedUserId", description="The user that updated the image")
    sensitive: typing.Optional[bool] = pydantic.Field(description="Flag for a sensitive content warning")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
