# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .app_shared_v_1_schema_audio_segment import AppSharedV1SchemaAudioSegment
from .app_shared_v_1_schema_shot import AppSharedV1SchemaShot
from .video import Video

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Keyframe(pydantic.BaseModel):
    """
    A keyframe asset response
    """

    coactive_image_id: str = pydantic.Field(alias="coactiveImageId", description="The coactive image id")
    video: Video = pydantic.Field(description="The video the keyframe belongs to")
    shot: AppSharedV1SchemaShot = pydantic.Field(description="The video shot metadata")
    path: typing.Optional[str] = pydantic.Field(description="The original path of the asset.")
    sensitive: typing.Optional[bool] = pydantic.Field(description="Flag for a sensitive content warning")
    audio_segment: typing.Optional[AppSharedV1SchemaAudioSegment] = pydantic.Field(
        alias="audioSegment", description="Audio segment associated with the keyframe (if the asset_type is 'keyframe')"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
