# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .app_shared_v_0_schema_paged_meta_response import AppSharedV0SchemaPagedMetaResponse
from .column import Column
from .query_table_row import QueryTableRow

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class QueryResult(pydantic.BaseModel):
    """
    A response containing data to be represented in a table
    """

    meta: AppSharedV0SchemaPagedMetaResponse = pydantic.Field(description="Metadata for the set of data returned")
    data: typing.List[QueryTableRow] = pydantic.Field(description="The table rows")
    columns: typing.List[Column] = pydantic.Field(description="The table columns")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
